<template>
  <div>
    <v-container>
      <p class="display-3 font-weight-light	text-center pa-4">Блог</p>
      <div class="row">
        <div
          v-for="post in listPosts"
          :key='post.id'
          class="col-md-4 col-sm-3 col-xs-12">
          <v-card
            class="mx-auto"
            max-width="400"
            outlined
            tile
          >
            <v-img
              class="white--text align-end"
              height="400px"
              :src="post.photo"
            >
              <v-card-title>{{ post.title }}</v-card-title>
            </v-img>
            <v-card-subtitle class="pb-0">{{ post.title }}</v-card-subtitle>
            <v-card-text class="text--primary">
              <div>
                {{ post.text }}
              </div>
            </v-card-text>
            <v-card-actions>
              <v-btn
                @click="goTo(post.id)"
                color="orange"
                text
              >
                Read More
              </v-btn>
            </v-card-actions>
          </v-card>
        </div>
      </div>
      <Pagination
        :total="total"
        :item="pageSize"
        @page-changed="loadListPost"
      />
    </v-container>
  </div>
</template>

<script>
import Pagination from "@/components/Pagination";

export default {
  components: { Pagination },
  name: 'Blog',
  data() {
    return {
      listPosts: [],
      token: localStorage.getItem('token'),
      page: 1,
      total: 0,
      pageSize: 1
    }
  },
  created() {
    this.loadListPost(this.page)
    this.$setTitle('Блог')
  },
  methods: {
    async loadListPost(pageNumber) {
      this.$store.commit('setLoading', true)
      this.listPosts = await axios.get(
        `${this.$store.getters.getServerUrl}api/v1/posts/?page=${pageNumber}`)
        .then(r => r.data)
        .then(r => {
          this.total = r.count,
            this.pageSize = r.page_size
          return r.results
        })
      this.$store.commit('setLoading', false)
    },
    goTo(id) {
      this.$router.push({ name: 'Post', params:{ id: id } })
    }
  }
}
</script>
